> ## Documentation Index > Fetch the complete documentation index at: https://support.keypro.fi/llms.txt > Use this file to discover all available pages before exploring further. # Get device group details > Operation is used to retrieve full details of given device group id. Available from product version 3.4. ## OpenAPI ````json GET /devicegroups/{id}/ { "openapi": "3.0.4", "info": { "title": "KeyCom REST API", "termsOfService": "https://www.keypro.fi/en/terms-of-service", "contact": { "name": "Keypro Oy", "url": "https://keypro.fi/", "email": "keypro@keypro.fi" }, "license": { "name": "Copyright (C) Keypro Oy. All rights reserved.", "url": "https://www.keypro.fi/" }, "version": "2.0.0" }, "servers": [ { "url": "/api/v2" } ], "tags": [ { "name": "Plan", "description": "Plan related operations." }, { "name": "FreeArea", "description": "FreeArea related operations." }, { "name": "FreeLine", "description": "FreeLine related operations." }, { "name": "FreeText", "description": "FreeText related operations." }, { "name": "FreeTextComponent", "description": "FreeText component related operations." }, { "name": "Address", "description": "Building address related operations." }, { "name": "Apartment", "description": "Building apartments related operations." }, { "name": "Extra Attribute", "description": "Extra attributes related operations." }, { "name": "Extra Value", "description": "Extra attribute values related operations." }, { "name": "EAV Enum", "description": "EAV Enum value related operations." }, { "name": "EAV Enum Group", "description": "EAV Enum group related operations." }, { "name": "External Document", "description": "External documents related operations." }, { "name": "Attached Document", "description": "Attached Documents related operations." }, { "name": "Collections", "description": "Collection related operations." }, { "name": "Source system apartment", "description": "External source system derived apartment related operations." }, { "name": "Source system address", "description": "External source system derived address related operations." }, { "name": "Address alias", "description": "Address aliases related operations" }, { "name": "TxtConstant", "description": "TxtConstants related operations." }, { "name": "Point", "description": "Point objects related operations." }, { "name": "Survey Constant", "description": "Survey Constants related operations." }, { "name": "Survey Point", "description": "Survey Points related operations." }, { "name": "Survey Line String", "description": "Survey Line Strings related operations." }, { "name": "Template Catalog", "description": "Template Catalog related operations." }, { "name": "Route Following", "description": "Route following related operations." }, { "name": "Contact Person", "description": "Contact person related operations." }, { "name": "Contact Person Connection", "description": "Contact person connection related operations." }, { "name": "Telecom premises", "description": "Telecom premises related operations." }, { "name": "Device", "description": "Device related operations." }, { "name": "Device Group", "description": "Device Group related operations." }, { "name": "Splice", "description": "Telecom Splice related operations." }, { "name": "Telecom Conduit", "description": "Telecom Conduit related operations." }, { "name": "Telecom Conduit Link", "description": "Operations related to putting Telecom Cables and Ducts into Conduits." }, { "name": "Telecom Duct", "description": "Telecom Duct related operations." }, { "name": "Telecom Duct Link", "description": "Operations related to putting Telecom Cables into Ducts." }, { "name": "Telecom Conduit Connection", "description": "Operations related to connecting Conduits and endpoints." }, { "name": "Telecom Cable Connection", "description": "Operations related to connecting Cables and endpoints" }, { "name": "Telecom Thread/Port Connection", "description": "Operations related to connecting and disconnecting telecom cable threads and device ports" }, { "name": "Telecom Duct Connection", "description": "Operations related to connecting Telecom Ducts to Telecom Premises or Manhole." }, { "name": "Manhole", "description": "Telecom Manhole related operations." }, { "name": "Cable", "description": "Telecom Cable related operations." }, { "name": "Cable Appendix", "description": "Cable Appendix operations for connecting Cables to loops. Manages the relationship between Cables and loops, automatically adjusting Cable extra_length when appendixes are created, updated, or deleted." }, { "name": "Supercable", "description": "Telecom Supercable related operations." }, { "name": "Cross connection point", "description": "Cross connection point related operations." }, { "name": "Service Area", "description": "Service Area related operations." }, { "name": "Exchange Area", "description": "Exchange Area related operations." }, { "name": "Telecom Area", "description": "Telecom Area related operations." }, { "name": "Routefollower", "description": "Routefollower related operations." }, { "name": "Circuit", "description": "Circuit related operations." }, { "name": "Circuit Location", "description": "Circuit installation location related operations." }, { "name": "Circuit Section", "description": "Circuit section related operations." }, { "name": "Circuit Reservation Data", "description": "Circuit reservation data view and search operations." }, { "name": "Customer", "description": "Customer data related operations." }, { "name": "Passed Services", "description": "Passed Services related operations." }, { "name": "Circuit Connection", "description": "Circuit logical reservations related operations." }, { "name": "Circuit Physical Reservation", "description": "Circuit physical reservations related operations." }, { "name": "Create connections", "description": "Operation used to create new connections." }, { "name": "Terminal type", "description": "Terminal types related operations." }, { "name": "Logical connections", "description": "Logical connections related operations." }, { "name": "Circuit Services", "description": "Operations provided by micro services." }, { "name": "Contract", "description": "Contract related operations." }, { "name": "Contract Link", "description": "Contract link related operations." }, { "name": "Pole", "description": "Pole related operations." }, { "name": "Circuit faults", "description": "Circuit faults related operations." }, { "name": "Duct groups", "description": "Duct groups related operations." }, { "name": "Duct group rows", "description": "Duct group rows related operations." }, { "name": "Threads", "description": "Cable thread related operations." }, { "name": "Task", "description": "Task related operations." }, { "name": "Subregion", "description": "Subregion related operations." }, { "name": "SAttribute", "description": "SAttribute related operations." }, { "name": "Fault", "description": "Fault related operations." }, { "name": "Maintenance history", "description": "Maintenance history related operations." }, { "name": "Deflection", "description": "Deflection related operations." }, { "name": "Fault Component", "description": "Fault Component related operations." }, { "name": "Task Comment", "description": "Task comment related operations." }, { "name": "FaultComponentFault", "description": "FaultComponentFault related operations." } ], "paths": { "/devicegroups/{id}/": { "get": { "tags": [ "Device Group" ], "summary": "Get device group details", "description": "Operation is used to retrieve full details of given device group id. Available from product version 3.4.\n", "operationId": "getDeviceGroupDetails", "parameters": [ { "name": "id", "in": "path", "description": "Id of device group", "required": true, "schema": { "type": "integer" } } ], "responses": { "200": { "description": "Device Group", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/DeviceGroup" }, "example": { "clazz": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "DEVICE", "id": 14690, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/DEVICE/", "logical_txt": "Kanavointilaite", "num_value": 2.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Conduiting device" }, "comments": "test", "devices": [ { "availabilityEnd": null, "availabilityStart": null, "clazz": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "DEVICE", "id": 236390, "list_url": "https://keycom.example.com/v2/txt_constants/groupname/DEVICE/", "logical_txt": "DSL-Laitepaikka", "num_value": 9.0, "num_value2": 1.0, "num_value3": 1.0, "num_value4": 251970.0, "txt": "DSL port" }, "connectors": 128, "fcode": "1111", "id": 35210, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 230, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Kuitu", "num_value": 1.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Fiber" }, "type": "DSL-laitepaikka" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "DEVICE", "id": 232390, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/DEVICE/", "logical_txt": "Hylly", "num_value": 5.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Shelf" }, "connectors": 0, "fcode": "2222", "id": 35290, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 250, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Hybridi", "num_value": null, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Hybrid" }, "type": "Hylly" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "DEVICE", "id": 232390, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/DEVICE/", "logical_txt": "Hylly", "num_value": 5.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Shelf" }, "connectors": 0, "fcode": "3333", "id": 35290, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 250, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Hybridi", "num_value": null, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Hybrid" }, "type": "Hylly" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": null, "connectors": 40, "fcode": "44444", "id": 2010, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 210, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Kupari", "num_value": 0.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Copper" }, "type": "Pääte 40" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": null, "connectors": 40, "fcode": "55555", "id": 2010, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 210, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Kupari", "num_value": 0.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Copper" }, "type": "Pääte 40" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": null, "connectors": 40, "fcode": "666666", "id": 2010, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 210, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Kupari", "num_value": 0.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Copper" }, "type": "Pääte 40" }, { "availabilityEnd": null, "availabilityStart": null, "clazz": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "DEVICE", "id": 14730, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/DEVICE/", "logical_txt": "Räkki", "num_value": 4.0, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Rack" }, "connectors": 0, "fcode": "777777", "id": 35270, "insertOnlyAsGroup": true, "listUrl": "https://keycom.example.com/api/v2/types/", "technology": { "availability_end_ts": null, "availability_start_ts": null, "available": true, "groupname": "TERMINAL_TECH", "id": 250, "list_url": "https://keycom.example.com/api/v2/txt_constants/groupname/TERMINAL_TECH/", "logical_txt": "Hybridi", "num_value": null, "num_value2": null, "num_value3": null, "num_value4": null, "txt": "Hybrid" }, "type": "19\" räkki 42U" } ], "id": 1, "name": "xyz" } } } }, "401": { "$ref": "#/components/responses/Http401" }, "404": { "$ref": "#/components/responses/Http404" } }, "security": [ { "Token": [] } ] } } }, "components": { "schemas": { "DeviceGroup": { "type": "object", "properties": { "clazz": { "$ref": "#/components/schemas/TerminalTypeClass" }, "comments": { "type": "string", "description": "comments" }, "createdBy": { "type": "string", "description": "User who created the device group", "readOnly": true }, "createdTs": { "type": "string", "description": "Timestamp when the device group was created", "format": "date-time", "readOnly": true }, "devices": { "type": "array", "items": { "$ref": "#/components/schemas/TerminalType" } }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "name": { "type": "string", "description": "name" }, "updatedBy": { "type": "string", "description": "User who last updated the device group", "readOnly": true }, "updatedTs": { "type": "string", "description": "Timestamp when the device group was last updated", "format": "date-time", "readOnly": true } } }, "TerminalTypeClass": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "DEVICE, CTV_DEVICE" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Terminal type class" }, "TerminalType": { "type": "object", "properties": { "availabilityEnd": { "type": "string", "description": "Availability end date and time", "format": "date-time" }, "availabilityStart": { "type": "string", "description": "Availability start date and time", "format": "date-time" }, "clazz": { "$ref": "#/components/schemas/TerminalTypeClass" }, "connectors": { "type": "integer", "description": "Connectors" }, "fcode": { "type": "integer", "description": "Feature code" }, "id": { "type": "integer", "description": "Primary key", "readOnly": true }, "insertOnlyAsGroup": { "type": "boolean", "description": "Type can be inserted only as part of a device group. Null means false. To list types insertable as a single device, filter with `not__insertOnlyAsGroup=true` (keeps false and null). Available from product version 2026.4.", "nullable": true }, "listUrl": { "type": "string", "description": "Url to fetch all constants from terminal types", "format": "url" }, "technology": { "$ref": "#/components/schemas/TerminalTech" }, "type": { "type": "string", "description": "Type" } }, "description": "Terminal type" }, "ErrorDetailsResponse": { "required": [ "details" ], "type": "object", "properties": { "details": { "type": "string", "description": "Detailed description of error" } }, "description": "Standard error response payload" }, "TerminalTech": { "required": [ "id", "groupname", "logical_txt", "txt", "list_url" ], "type": "object", "properties": { "availability_end_ts": { "type": "string", "description": "Ending date time for availability", "format": "date-time" }, "availability_start_ts": { "type": "string", "description": "Beginning date time for availability", "format": "date-time" }, "available": { "type": "boolean", "description": "Is object deemed as available. Based on availability_start_ts and availability_end_ts values.", "readOnly": true }, "groupname": { "enum": [ "TERMINAL_TECH" ], "description": "Group name of constant" }, "id": { "type": "integer", "description": "Unique id of constant" }, "list_url": { "type": "string", "description": "Url to fetch all constants from this group", "format": "url" }, "logical_txt": { "type": "string", "description": "Logical textual value" }, "num_value": { "type": "number", "description": "Numeric value", "format": "float" }, "num_value2": { "type": "number", "description": "Numeric value 2", "format": "float" }, "num_value3": { "type": "number", "description": "Numeric value 3", "format": "float" }, "num_value4": { "type": "number", "description": "Numeric value 4", "format": "float" }, "txt": { "type": "string", "description": "Human readable textual representation" } }, "description": "Terminal type technology" } }, "responses": { "Http401": { "description": "Authentication credentials are missing or invalid", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorDetailsResponse" }, "example": { "details": "Authentication credentials were not provided" } } } }, "Http404": { "description": "Object was not found", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/ErrorDetailsResponse" }, "example": { "details": "Not found." } } } } }, "securitySchemes": { "Token": { "type": "apiKey", "description": "Token issued for API consumer.", "name": "Authorization", "in": "header" } } } } ````